#!/usr/local/bin/perl
#### ȥåХå for GNS tb.cgi V4.00 
#### Copyright 1998-2005 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### History: 
#### 2005/04/22 V4.00  

require "tb.ph";
require "config.ph";

if ( $TB_RECEIVE == 0 ) {
	&err_refuse();
	exit;
}

{
	&CreateSemaphore();

	$SYSTIME = time;
	( $S_sec,$S_min,$S_hour,$S_mday,$S_mon,$S_year,$S_wday,$S_yday,$S_isdst ) = localtime( $SYSTIME );
	$S_date = sprintf( "%04d/%02d/%02d %02d:%02d:%02d", $S_year+1900, $S_mon+1, $S_mday+0, $S_hour+0, $S_min+0, $S_sec+0 );

	$tbtourl = substr( $ENV{'PATH_INFO'}, 1 );

	$postparam = "";
	if ( $ENV{'REQUEST_METHOD'} eq "POST" ) {
		$len = $ENV{'CONTENT_LENGTH'} + 0;
		read( STDIN, $postparam, $len );
	} elsif ( $ENV{'REQUEST_METHOD'} eq "GET" ) {
	} else {
		&err_method();
		die;
	}
	$queryparam = $ENV{'QUERY_STRING'};

	# POST
	@part = split( '&', $postparam );
	foreach $i (@part) {
		( $variable, $value ) = split( '=', $i );
		$value =~ tr/+/ /;
		$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
#		&jcode'convert( *value, 'sjis' );
		$value =~ s/\015\012/\012/g;
		$value =~ s/\015/\012/g;
		$post{$variable} = $value;
	}
	$postparam =~ s/[\015\012]+//g;

	# QUERY
	@part = split( '&', $queryparam );
	foreach $i (@part) {
		( $variable, $value ) = split( '=', $i );
#		$value =~ tr/+/ /;
#		$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
#		&jcode'convert( *value, 'sjis' );
		$value =~ s/\015\012/\012/g;
		$value =~ s/\015/\012/g;
		$cgi{$variable} = $value;
	}

	# å
	$year = substr( $tbtourl, 0, 4 )+0;
	$month = substr( $tbtourl, 4, 2 )+0;
	$day = substr( $tbtourl, 6, 2 )+0;
	$titleid = substr( $tbtourl, 8, 2 )+0;
	if ( ($year < 1980) || ($year > 2099)
	  || ($month < 1) || ($month > 12)
	  || ($day < 1) || ($day > 31)
	  || ($titleid < 1)
	) {
		&err_overrange( $tbtourl );
		die;
	}

	# "?__mode=rss"ʤɽ
	if ( $cgi{'__mode'} eq 'rss' ) {
		&ListTrackbackPing();
		&doterm();
		exit;
	}

	# GETʤȥåХåӥ塼Location
	if ( $ENV{'REQUEST_METHOD'} eq "GET" ) {
#		printf(
#		  "Location: %s%04d%02dt.html\n\n",
#		  $TBCM_BASEURL, $year, $month
#		);
		$s = sprintf( "http://%s%s%s", $ENV{"SERVER_NAME"}, $ENV{"SCRIPT_NAME"}, $ENV{"PATH_INFO"} );
		printf( "Content-Type: text/plain;\n\nCopy Trackback URL: %s", $s );
		&doterm();
		exit;
	}

	# ȥåХåΥǥ
	$tbfromurl = $post{"url"};
	$tbfromurl =~ tr/+/ /;
	$tbfromurl =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
	if ( $tbfromurl !~ /http:\/\// ) {
		&err_badtbfromurl( $tbfromurl );
		die;
	}

	# Ƹ
	$http_user_agent = $ENV{"HTTP_USER_AGENT"};
	$remote_addr = $ENV{"REMOTE_ADDR"};
	$remote_host = $ENV{"REMOTE_HOST"};
	if ( $remote_host eq "" ) {
		$remote_host = $remote_addr;
	}
	if ( $remote_host eq $remote_addr ) {
		$remote_host = gethostbyaddr( pack( 'C4', split( /[.]/, $remote_addr ) ), 2 ) || $remote_addr;
	}

	# ǥ
	open( FOUT, "|$TB_NKFCMD -e > $TB_LOG_DIR/%tbarg.txt" );
	foreach $i (keys(%post)) {
		print FOUT "$i: $post{$i}\n";
	}
	close( FOUT );
	undef( %post2 );
	open( FIN, "$TB_LOG_DIR/%tbarg.txt" );
	while( <FIN> ) {
		chomp;
		if ( $_ =~ m/^([^:]*): (.*)$/ ) {
			$post2{$1} = $2;
		}
	}
	close( FIN );
	unlink( "$TB_LOG_DIR/%tbarg.txt" );

	# ե륿
	open( FIN, "$TB_NKFCMD -e tbfilter.txt|" );
	while( <FIN> ) {
		chomp;
		next if ( $_ =~ m/^#/ );
		if ( $_ =~ m/^([^:]*): (.*)$/ ) {
			$cmd = $1;
			$arg = $2;
			if ( $cmd eq "title" ) {
				if ( $post2{"title"} =~ m/${arg}/ ) {
					&err_refused( "by title filter" );
					die;
				}
			} elsif ( $cmd eq "name" ) {
				if ( $post2{"blog_name"} =~ m/${arg}/ ) {
					&err_refused( "by blog_name filter" );
					die;
				}
			} elsif ( $cmd eq "url" ) {
				if ( $post2{"url"} =~ m/${arg}/i ) {
					&err_refused( "by url filter" );
					die;
				}
			} elsif ( $cmd eq "excerpt" ) {
				if ( $post2{"excerpt"} =~ m/${arg}/ ) {
					&err_refused( "by excerpt filter" );
					die;
				}
			} elsif ( $cmd eq "fromadr" ) {
				if ( ($remote_addr =~ m/${arg}/) ||
				     ($remote_host =~ m/${arg}/) ) {
					&err_refused( "by fromadr filter" );
					die;
				}
			}
		}
	}

	# ̥ե
	if ( !(-e "$TB_LOG_DIR/$year") ) {
		$umaskback = umask( oct($TB_LOG_DIR_PERM) ^ 0777 );
		mkdir( "$TB_LOG_DIR/$year", oct($TB_LOG_DIR_PERM) ) || die "cannot create directory [$TB_LOG_DIR/$year].";
		umask( $umaskback );
	}

	$umaskback = umask( oct($TB_LOG_PERM) ^ 0666 );

	# ̥¸
	$fout = sprintf( "$TB_LOG_DIR/$year/%02d.log", $month );
	open( FOUT, ">>$fout" ) || die "[$fout] cannot write. Check [$fout] permission.";
	print FOUT "$tbtourl $postparam $tbfromurl $S_date $remote_addr $remote_host \"$http_user_agent\"\n";
	close( FOUT );

	# ǿ¸
	$fout = "$TB_LOG_DIR/latesttb.log";
	open( FIN, "$fout" );
	$lines = 0;
	while ( <FIN> ) {
		$line[$lines++] = $_;
	}
	close( FIN );
	$line[$lines++] = "$tbtourl $postparam $tbfromurl $S_date $remote_addr $remote_host \"$http_user_agent\"\n";
	$ls = $lines - $TB_LATEST_N;
	$ls = 0 if ( $ls < 0 );
	open( FOUT, ">$fout" ) || die "[$fout] cannot write. Check [$fout] permission.";
	for ( $i=$ls; $i<$lines; $i++ ) {
		print FOUT $line[$i];
	}
	close( FOUT );

	umask( $umaskback );

	&doterm();

	# ȥåХåӥ塼ڡ
	if ( $TBCM_MAKEVIEW ) {
		chdir( $TB_MKTBVIEW_PATH );
		system( "$TB_PERLCMD $TB_MKTBVIEW_PL $year $month $day" );
	}

	# Υ᡼
	if ( $TB_NOTIFYMAIL ) {
		$cmd = sprintf( "| $TB_MAILCMD -s \"$TB_MAILSUBJECT %04d/%02d/%02d-%02d\" $TBCM_MAILTO", $year, $month, $day, $titleid );
# print "$cmd\n";
		if ( !open( CMD, $cmd ) ) {
			&err_sendmail( $cmd );
			die;
		}
		printf( CMD "Receive Trackback from:\n  $tbfromurl\n" );
		printf( CMD "to following title:\n  $TBCM_BASEURL%04d%02dt.html#$ANCHOR%02d%02dtb\n", $year, $month, $day, $titleid );
		print CMD "\n";
		close( CMD );
	}

	# ơ֤
	print <<message;
Content-Type: text/xml; charset=\"iso-8859-1\"

<?xml version="1.0" encoding="iso-8859-1"?>
<response>
<error>0</error>
<message>Accept Trackback from ($tbfromurl) to ($tbtourl)</message>
</response>
message

}

########################################################################

sub err_refused {
	local($s) = @_;
	print <<message;
Content-Type: text/plain;

<?xml version="1.0" encoding="iso-8859-1"?>
<response>
<error>1</error>
<message>Refused ($s)</message>
</response>
message
}

sub err_method {
	print <<message;
Content-Type: text/plain;

This CGI can receive only POST method.
message
}

sub err_badtbfromurl {
	local($s) = @_;
	print <<message;
Content-Type: text/xml; charset=\"iso-8859-1\"

<?xml version="1.0" encoding="iso-8859-1"?>
<response>
<error>1</error>
<message>Bad Trackback From ($s)</message>
</response>
message
}

sub err_overrange {
	local($s) = @_;
	print <<message;
Content-Type: text/xml; charset=\"iso-8859-1\"

<?xml version="1.0" encoding="iso-8859-1"?>
<response>
<error>1</error>
<message>Trackback ID($s) Range Over</message>
</response>
message
}

sub err_sendmail {
	local($s) = @_;
	print <<message;
Content-Type: text/plain;

Cannot send notify mail.\n[$s]
message
}

####################################################################

sub CreateSemaphore {
	local( $abort_counter ) = 60;
	local( $not_aborted ) = 1;
	$SIG{'__DIE__'} = $SIG{'TRAP'} = $SIG{'ABRT'} = $SIG{'STOP'} = $SIG{'TERM'} = $SIG{'INT'} = $SIG{'KILL'} = $SIG{'QUIT'} = $SIG{'HUP'} = $SIG{'PIPE'} = 'doterm';
	while(!mkdir($LOCKFILE)) {
		$abort_counter--;
		if ( $abort_counter eq 0 ) {
			$not_aborted = 0;
			last;
		}
		sleep(1);
	}

	if ( $not_aborted == 0 ) {
		&doterm();
		print "Content-Type: text/plain\n\n";
		print "Cannot create semaphore.  Please contact diary owner.\n";
		die "Cannot create semaphore [$GNS_LOCKFILE].";
	}

	return (0);
}

sub doterm {
	rmdir($LOCKFILE);
	return;
}

####################################################################

sub RSSCleaning {
	local( $s ) = shift;
	$s =~ s:<[^>]*>: :g;
	$s =~ s:\&[^;]*;::g;
	$s =~ s:\&::g;
	$s =~ s:[ ]+: :g;
	$s =~ s:\n::g;
	return ($s);
}

sub ListTrackbackPing {

	# إå
	print <<message;
Content-Type: text/xml; charset=\"utf-8\"

<?xml version="1.0" encoding="utf-8"?>
<response>
<error>0</error>
<rss version="0.91">
<channel>
message

	# ̥¸
	$fin = sprintf( "$TB_LOG_DIR/$year/%02d.log", $month );
	if ( open( FIN, "<$fin" ) ) {

		print "<title>TB:</title>\n";
		while ( $line = <FIN> ) {
			chomp( $line );
			next if ( $line eq "" );
			next if ( $line =~ "^#" );
			@col = split( " ", $line );
			next if ( $col[2] eq 'COMMENT' );
			$tbyear = substr( $col[0], 0, 4 ) +0;
			$tbmonth = substr( $col[0], 4, 2 ) +0;
			$tbday = substr( $col[0], 6, 2 ) +0;
			$tbtitleid = substr( $col[0], 8, 2 ) +0;
			if ( ($tbyear == $year) &&
			     ($tbmonth == $month) &&
			     ($tbday == $day) &&
			     ($tbtitleid == $titleid) 
			   ) {
				@expr = split( '&', $col[1] );
				foreach $s (@expr) {
					( $variable, $value ) = split( '=', $s );
					$value =~ tr/+/ /;
					$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
					$value =~ s/(\x0d|\x0a)+//eg;
					$param{$variable} = $value;
				}
				print "<item>\n";
				$s = &RSSCleaning( $param{'title'} );
				print "<title>$s</title>\n";
				$s = $param{'url'};
				print "<link>$s</link>\n";
				$s = &RSSCleaning( $param{'excerpt'} );
				print "<description>$s</description>\n";
				print "</item>\n";
			}
		}

		close( FIN );
	}

	# եå
	print <<message;
</channel>
</rss>
</response>
message

}


####################################################################

# [EOF]
